Hooks:PostHook(PlayerDamage,"init","haloannouncer_register_on_revive_success_hook",function(self,unit)
	self._listener_holder:add(
		"haloannouncer_on_revive_success",
		{
			"on_revive_interaction_success"
		},
		callback(HaloAnnouncer,HaloAnnouncer,"OnReviveSuccess")
	)
end)


if not HaloAnnouncer:IsSafeMode() then
	
	local orig_dmg_mel = Hooks:GetFunction(PlayerDamage,"damage_melee")
	function PlayerDamage:damage_melee(attack_data,...)
		local bleed_out = self._bleed_out
		local result = {orig_dmg_mel(self,attack_data,...)}

		if not bleed_out and self._bleed_out then 
			if attack_data.attacker_unit then 
				if managers.criminals:character_by_unit(attack_data.attacker_unit) then
					HaloAnnouncer:AddMedal("betrayed")
				else
					HaloAnnouncer:RegisterKiller(attack_data.attacker_unit,managers.network:session():local_peer():id())
				end
			end
		end
		return unpack(result)
	end

	local orig_dmg_bul = Hooks:GetFunction(PlayerDamage,"damage_bullet")
	function PlayerDamage:damage_bullet(attack_data,...)
		local bleed_out = self._bleed_out
		local result = {orig_dmg_bul(self,attack_data,...)}
		if not bleed_out and self._bleed_out then 
			if attack_data.attacker_unit then 
				if managers.criminals:character_by_unit(attack_data.attacker_unit) then
					HaloAnnouncer:AddMedal("betrayed")
				else
					HaloAnnouncer:RegisterKiller(attack_data.attacker_unit,managers.network:session():local_peer():id())
				end
			end
		end
		return unpack(result)
	end	

	local orig_dmg_exp = Hooks:GetFunction(PlayerDamage,"damage_explosion")
	function PlayerDamage:damage_explosion(attack_data,...)
		local bleed_out = self._bleed_out
		local result = {orig_dmg_exp(self,attack_data,...)}
		if not bleed_out and self._bleed_out then 
			if attack_data.attacker_unit then 
				if managers.criminals:character_by_unit(attack_data.attacker_unit) then
					HaloAnnouncer:AddMedal("betrayed")
				else
					HaloAnnouncer:RegisterKiller(attack_data.attacker_unit,managers.network:session():local_peer():id())
				end
			end
		end
		return unpack(result)
	end
	
end